/*
	A basic extension of the java.applet.Applet class
 */

import java.awt.*;
import java.applet.*;
import java.lang.Math;
import java.text.DecimalFormat;

public class TerraSim1_1 extends java.applet.Applet 
{
	//{{GLOBAL NUMERICAL VARIABLES
	double pole; // Polar reservoir of CO2
	double regolith; // Regolith capacity of CO2
	double Pr; // Regolith inventory of CO2
	double totCO2; // Total CO2 inventory of Mars
	double Td; // Temperature increment to outgas 1/e of regolith
    double S, a; //Insolation factor and albedo
    double PCO2, PN2, PCH4, PNH3, PCFC; // Partial pressures
    double Tb, Ts, Tp, Tt; // Effective, global surface, polar and tropical temperatures
    double C; // Normalization constant for regolith calculations
    double dT; // Delta T
    double iceLat, habRatio; // Habitable parameters
    //}}
    
    //{{DECLARE OUTPUT FORMATS
    DecimalFormat f1 = new DecimalFormat("###0.0");
    DecimalFormat f2 = new DecimalFormat("#0.00");
    DecimalFormat fper = new DecimalFormat("##0.0%");
    //}}
    
    //{{DECLARE_CONTROLS
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.TextField txtAlb = new java.awt.TextField();
	java.awt.TextField txtIns = new java.awt.TextField();
	java.awt.TextField txtCO2 = new java.awt.TextField();
	java.awt.TextField txtCFC = new java.awt.TextField();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.TextField txtMGTK = new java.awt.TextField();
	java.awt.TextField txtPTK = new java.awt.TextField();
	java.awt.TextField txtTTK = new java.awt.TextField();
	java.awt.Button btnReset = new java.awt.Button();
	java.awt.Button btnCalc = new java.awt.Button();
	java.awt.Label label11 = new java.awt.Label();
	java.awt.Label label12 = new java.awt.Label();
	java.awt.Label label13 = new java.awt.Label();
	java.awt.TextField txtMGTC = new java.awt.TextField();
	java.awt.TextField txtPTC = new java.awt.TextField();
	java.awt.TextField txtTTC = new java.awt.TextField();
	java.awt.Label label14 = new java.awt.Label();
	java.awt.Label label15 = new java.awt.Label();
	java.awt.Label label16 = new java.awt.Label();
	java.awt.Label label17 = new java.awt.Label();
	java.awt.TextField txtDTK = new java.awt.TextField();
	java.awt.Label label18 = new java.awt.Label();
	java.awt.Label label19 = new java.awt.Label();
	java.awt.TextField txtN2 = new java.awt.TextField();
	java.awt.Label label20 = new java.awt.Label();
	java.awt.Label label21 = new java.awt.Label();
	java.awt.Label label22 = new java.awt.Label();
	java.awt.TextField txtNH3 = new java.awt.TextField();
	java.awt.TextField txtCH4 = new java.awt.TextField();
	java.awt.Label label23 = new java.awt.Label();
	java.awt.Label label24 = new java.awt.Label();
	java.awt.TextField txtH2O = new java.awt.TextField();
	java.awt.Label label25 = new java.awt.Label();
	java.awt.Label label26 = new java.awt.Label();
	java.awt.Label label27 = new java.awt.Label();
	java.awt.TextField txtPtot = new java.awt.TextField();
	java.awt.Label label28 = new java.awt.Label();
	java.awt.Label label29 = new java.awt.Label();
	java.awt.Label label30 = new java.awt.Label();
	java.awt.TextField txticeLat = new java.awt.TextField();
	java.awt.TextField txthabRatio = new java.awt.TextField();
	java.awt.Label label31 = new java.awt.Label();
	java.awt.TextField txtPole = new java.awt.TextField();
	java.awt.Label label32 = new java.awt.Label();
	java.awt.TextField txtRegolith = new java.awt.TextField();
	java.awt.Label label33 = new java.awt.Label();
	java.awt.Label label34 = new java.awt.Label();
	java.awt.Label label35 = new java.awt.Label();
	java.awt.TextField txtTd = new java.awt.TextField();
	java.awt.Label label36 = new java.awt.Label();
	java.awt.Label label37 = new java.awt.Label();
	java.awt.TextField txtPr = new java.awt.TextField();
	java.awt.Label label38 = new java.awt.Label();
	//}}
    
	public void init()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(618,491);
		label1.setText("Terraforming Simulator V1.0");
		label1.setAlignment(java.awt.Label.CENTER);
		add(label1);
		label1.setFont(new Font("Dialog", Font.PLAIN, 16));
		label1.setBounds(156,12,252,24);
		label2.setText("Albedo");
		add(label2);
		label2.setFont(new Font("Dialog", Font.PLAIN, 14));
		label2.setBounds(12,120,115,25);
		label3.setText("Insolation Factor");
		add(label3);
		label3.setFont(new Font("Dialog", Font.PLAIN, 14));
		label3.setBounds(12,156,115,25);
		label4.setText("CO2 Pressure");
		add(label4);
		label4.setFont(new Font("Dialog", Font.PLAIN, 14));
		label4.setBounds(12,192,115,25);
		label5.setText("CFC Pressure");
		add(label5);
		label5.setFont(new Font("Dialog", Font.PLAIN, 14));
		label5.setBounds(324,228,115,25);
		add(txtAlb);
		txtAlb.setBounds(168,120,60,25);
		add(txtIns);
		txtIns.setBounds(168,156,60,25);
		add(txtCO2);
		txtCO2.setBounds(168,192,60,25);
		add(txtCFC);
		txtCFC.setBounds(456,228,60,25);
		label6.setText("millibars");
		add(label6);
		label6.setFont(new Font("Dialog", Font.PLAIN, 14));
		label6.setBounds(240,192,60,26);
		label7.setText("microbars");
		add(label7);
		label7.setFont(new Font("Dialog", Font.PLAIN, 14));
		label7.setBounds(528,228,72,24);
		label8.setText("Mean global temperature");
		add(label8);
		label8.setBounds(12,312,144,24);
		label9.setText("Polar temperature");
		add(label9);
		label9.setBounds(12,348,120,24);
		label10.setText("Max tropical temperature");
		add(label10);
		label10.setBounds(12,384,144,24);
		txtMGTK.setEditable(false);
		add(txtMGTK);
		txtMGTK.setBounds(168,312,60,26);
		txtPTK.setEditable(false);
		add(txtPTK);
		txtPTK.setBounds(168,348,60,26);
		txtTTK.setEditable(false);
		add(txtTTK);
		txtTTK.setBounds(168,384,60,26);
		btnReset.setLabel("Reset");
		add(btnReset);
		btnReset.setBackground(java.awt.Color.lightGray);
		btnReset.setFont(new Font("Dialog", Font.PLAIN, 14));
		btnReset.setBounds(456,312,74,39);
		btnCalc.setLabel("Calculate");
		add(btnCalc);
		btnCalc.setBackground(java.awt.Color.lightGray);
		btnCalc.setFont(new Font("Dialog", Font.PLAIN, 14));
		btnCalc.setBounds(456,372,74,39);
		label11.setText("K");
		add(label11);
		label11.setFont(new Font("Dialog", Font.PLAIN, 14));
		label11.setBounds(252,312,24,25);
		label12.setText("K");
		add(label12);
		label12.setFont(new Font("Dialog", Font.PLAIN, 14));
		label12.setBounds(252,348,24,25);
		label13.setText("K");
		add(label13);
		label13.setFont(new Font("Dialog", Font.PLAIN, 14));
		label13.setBounds(252,384,24,25);
		txtMGTC.setEditable(false);
		add(txtMGTC);
		txtMGTC.setBounds(324,312,60,27);
		txtPTC.setEditable(false);
		add(txtPTC);
		txtPTC.setBounds(324,348,60,27);
		txtTTC.setEditable(false);
		add(txtTTC);
		txtTTC.setBounds(324,384,60,27);
		label14.setText("C");
		add(label14);
		label14.setFont(new Font("Dialog", Font.PLAIN, 14));
		label14.setBounds(408,312,24,25);
		label15.setText("C");
		add(label15);
		label15.setFont(new Font("Dialog", Font.PLAIN, 14));
		label15.setBounds(408,348,24,25);
		label16.setText("C");
		add(label16);
		label16.setFont(new Font("Dialog", Font.PLAIN, 14));
		label16.setBounds(408,384,24,25);
		label17.setText("Delta T");
		add(label17);
		label17.setBounds(12,420,144,24);
		txtDTK.setEditable(false);
		add(txtDTK);
		txtDTK.setBounds(168,420,60,26);
		label18.setText("degrees");
		add(label18);
		label18.setFont(new Font("Dialog", Font.PLAIN, 12));
		label18.setBounds(252,420,60,24);
		label19.setText("N2/O2 Pressure");
		add(label19);
		label19.setFont(new Font("Dialog", Font.PLAIN, 14));
		label19.setBounds(12,228,119,24);
		add(txtN2);
		txtN2.setBounds(168,228,60,24);
		label20.setText("millibars");
		add(label20);
		label20.setFont(new Font("Dialog", Font.PLAIN, 14));
		label20.setBounds(240,228,60,24);
		label21.setText("NH3 Pressure");
		add(label21);
		label21.setFont(new Font("Dialog", Font.PLAIN, 14));
		label21.setBounds(324,192,115,25);
		label22.setText("CH4 Pressure");
		add(label22);
		label22.setFont(new Font("Dialog", Font.PLAIN, 14));
		label22.setBounds(324,156,115,25);
		add(txtNH3);
		txtNH3.setBounds(456,192,60,25);
		add(txtCH4);
		txtCH4.setBounds(456,156,60,25);
		label23.setText("microbars");
		add(label23);
		label23.setFont(new Font("Dialog", Font.PLAIN, 14));
		label23.setBounds(528,192,72,24);
		label24.setText("microbars");
		add(label24);
		label24.setFont(new Font("Dialog", Font.PLAIN, 14));
		label24.setBounds(528,156,72,24);
		txtH2O.setEditable(false);
		add(txtH2O);
		txtH2O.setBounds(456,120,60,24);
		label25.setText("H2O Pressure");
		add(label25);
		label25.setFont(new Font("Dialog", Font.PLAIN, 14));
		label25.setBounds(324,120,115,25);
		label26.setText("millibars");
		add(label26);
		label26.setFont(new Font("Dialog", Font.PLAIN, 14));
		label26.setBounds(528,120,60,24);
		label27.setText("Total Pressure");
		add(label27);
		label27.setFont(new Font("Dialog", Font.PLAIN, 14));
		label27.setBounds(12,264,119,24);
		txtPtot.setEditable(false);
		add(txtPtot);
		txtPtot.setBounds(168,264,60,24);
		label28.setText("millibars");
		add(label28);
		label28.setFont(new Font("Dialog", Font.PLAIN, 14));
		label28.setBounds(240,264,60,24);
		label29.setText("Planet frozen above latitude");
		add(label29);
		label29.setBounds(12,456,156,24);
		label30.setText("Habitable percent of surface");
		add(label30);
		label30.setFont(new Font("Dialog", Font.PLAIN, 12));
		label30.setBounds(276,456,156,24);
		txticeLat.setEditable(false);
		add(txticeLat);
		txticeLat.setBounds(168,456,60,26);
		txthabRatio.setEditable(false);
		add(txthabRatio);
		txthabRatio.setBounds(456,456,60,26);
		label31.setText("Cap CO2 Inventory");
		add(label31);
		label31.setFont(new Font("Dialog", Font.PLAIN, 14));
		label31.setBounds(12,48,132,24);
		add(txtPole);
		txtPole.setBounds(168,48,60,25);
		label32.setText("Regolith CO2 Capacity");
		add(label32);
		label32.setFont(new Font("Dialog", Font.PLAIN, 14));
		label32.setBounds(12,84,156,24);
		add(txtRegolith);
		txtRegolith.setBounds(168,84,60,25);
		label33.setText("millibars");
		add(label33);
		label33.setFont(new Font("Dialog", Font.PLAIN, 14));
		label33.setBounds(240,48,60,26);
		label34.setText("millibars");
		add(label34);
		label34.setFont(new Font("Dialog", Font.PLAIN, 14));
		label34.setBounds(240,84,60,26);
		label35.setText("Regolith Td");
		add(label35);
		label35.setFont(new Font("Dialog", Font.PLAIN, 14));
		label35.setBounds(324,48,84,24);
		add(txtTd);
		txtTd.setBounds(456,48,60,25);
		label36.setText("K");
		add(label36);
		label36.setFont(new Font("Dialog", Font.PLAIN, 14));
		label36.setBounds(528,48,24,25);
		label37.setText("Regolith CO2");
		add(label37);
		label37.setFont(new Font("Dialog", Font.PLAIN, 14));
		label37.setBounds(324,84,96,24);
		add(txtPr);
		txtPr.setBounds(456,84,60,25);
		label38.setText("millibars");
		add(label38);
		label38.setFont(new Font("Dialog", Font.PLAIN, 14));
		label38.setBounds(528,84,60,26);
		//}}
	
		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		btnReset.addActionListener(lSymAction);
		btnCalc.addActionListener(lSymAction);
		//}}
		
		//{{INITIALIZE NUMERICAL SETTINGS
		reset();
		input();
		greenhouse();
		output();
		//}}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == btnReset)
				btnReset_ActionPerformed(event);
			else if (object == btnCalc)
				btnCalc_ActionPerformed(event);
		}
	}
	
	class OutOfRangeException extends ArithmeticException
	{
	    public OutOfRangeException()
	    {
	        super ("Input datum out of range: See User Guide");
        }
    }
        
	void btnReset_ActionPerformed(java.awt.event.ActionEvent event)
	{
        reset();
        input();
		greenhouse();
		output();
			 
	}

	void btnCalc_ActionPerformed(java.awt.event.ActionEvent event)
	{
		input();
		greenhouse();
		output();	 			 
	}

    void reset()
	{
	    txtPole.setText("50");
	    txtPr.setText("300");
	    txtRegolith.setText("300");
	    txtTd.setText("30");
	    txtAlb.setText("0.2");
	    txtIns.setText("1.0");
	    txtCO2.setText("0");
	    txtN2.setText("0.2");
	    txtCH4.setText("0");
	    txtNH3.setText("0");
	    txtCFC.setText("0");
    }
        
    void input()
    {
        String temp;
        Double n;
        showStatus ("");
        
        try
        {        
            temp = txtPole.getText();
            n = Double.valueOf(temp);
            pole = n.doubleValue();
            
            temp = txtRegolith.getText();
            n = Double.valueOf(temp);
            regolith = n.doubleValue();
            
            temp = txtPr.getText();
            n = Double.valueOf(temp);
            Pr = n.doubleValue();
            
            temp = txtTd.getText();
            n = Double.valueOf(temp);
            Td = n.doubleValue();
            
            temp = txtAlb.getText();
            n = Double.valueOf(temp);
            a = n.doubleValue();
            
            temp = txtIns.getText();
            n = Double.valueOf(temp);
            S = n.doubleValue();
            
            temp = txtCO2.getText();
            n = Double.valueOf(temp);
            PCO2 = n.doubleValue();
            
            temp = txtN2.getText();
            n = Double.valueOf(temp);
            PN2 = n.doubleValue();
            
            temp = txtCH4.getText();
            n = Double.valueOf(temp);
            PCH4 = n.doubleValue();        
            
            temp = txtNH3.getText();
            n = Double.valueOf(temp);
            PNH3 = n.doubleValue();        
            
            temp = txtCFC.getText();
            n = Double.valueOf(temp);
            PCFC = n.doubleValue();
            
            checkinput();
        }
        
        catch (NumberFormatException nfe)
        {
            showStatus ("Enter numerical data only");
        }
        
        catch (OutOfRangeException oore)
        {
            showStatus (oore.toString());
        }
        
        pole = pole / 1E3; // Convert millibars to bars
        Pr = Pr / 1E3; // Convert millibars to bars
        regolith = regolith / 1E3; // Convert millibars to bars
        PCO2 = PCO2 / 1E3; // Convert millibars to bars
        PN2 = PN2 / 1E3; // Convert millibars to bars
        PCH4 = PCH4 / 1E6; // Convert microbars to bars
        PNH3 = PNH3 / 1E6; // Convert microbars to bars
        PCFC = PCFC / 10; // Convert microbars to pascals
        C = regolith * Math.pow(0.006, -0.275) * Math.exp(149 / Td);
            // Normalization constant for regolith calculations
        totCO2 = Pr + pole + PCO2;
    }

    void greenhouse()
    {
        final double sigma = 0.0000000567; // Stefan-Boltzmann constant
        final int Sm = 589; //Present day martian solar constant
        double tH2O; // Water vapour opacity
        
        Tb = Math.pow(((1 - 0.2) * Sm) / (4 * sigma), 0.25);
            // Effective temperature of present day Mars
        Ts = Tb; // Initialize surface temperature
        Tp = Ts - 75; // Initialize polar temperature
        
        // Loop calculates surface temperature and iterates water vapour
        // opacity and CO2-cap dynamics 100 times
        
        for (int loop = 1; loop <= 100; loop++)
            {
                tH2O = Math.pow(PH2O(), 0.3);
                
                Ts = Math.pow(((1 - a) * Sm * S) / (4 * sigma), 0.25) 
                    * Math.pow((1 + tCO2() + tH2O + tCH4() + tNH3() + tCFC()), 0.25);
                // Mean global surface temperature
                Tp = Ts - 75 / (1 + 5 * Ptot()); // Polar temperature      
                
                PCO2 = PCO2();
            }        
        
        Tt = Ts * 1.1; // Max tropic temperature
        dT = Ts - Tb; // Delta T: degrees of warming over effective temperature
        
        biosphere();
    }
    
    void output()
    {
        txtCO2.setText(f1.format(PCO2 * 1000));
        txtPtot.setText(f2.format(Ptot() * 1000));
        txtH2O.setText(f2.format(PH2O() * 1000));
        txtPole.setText(f1.format(pole * 1000));
        txtPr.setText(f1.format(Pr * 1000));
        txtMGTK.setText(f1.format(Ts));
        txtPTK.setText(f1.format(Tp));
        txtTTK.setText(f1.format(Tt));
        txtDTK.setText(f1.format(dT));
        
        txtMGTC.setText(f1.format(Ts - 273));
        txtPTC.setText(f1.format(Tp - 273));
        txtTTC.setText(f1.format(Tt - 273));
        
        txticeLat.setText(f1.format(iceLat * 180 / Math.PI));
        txthabRatio.setText(fper.format(habRatio));
    }
    
    double PH2O()
        // Calculates water vapour pressure
    {
        final double Rh = 0.7; // Relative humidity
        final double Rgas = 8.314; // Gas constant for water
        final double Lheat = 43655.0; // Latent heat (?)
        final double P0 = 1.4E6; //Reference pressure
        
        return Rh * P0 * Math.exp(-Lheat / (Rgas * Ts));
    }
    
    double Ptot()
        // Calculates total atmospheric pressure
    {
        return PCO2 + PN2 + PCH4 + PNH3 + (PCFC / 1E5) + PH2O();
    }
    
    double tCO2()
        // Calculates opacity of CO2
    {
        return 0.9 * Math.pow(Ptot(), 0.45) * Math.pow(PCO2, 0.11);
    }
    
    double tCH4()
         // Calculates opacity of methane
    {
        return 0.5 * Math.pow(PCH4, 0.278);
    }
    
    double tNH3()
         // Calculates opacity of ammonia
    {
        return 9.6 * Math.pow(PNH3, 0.32);
    }
    
    double tCFC()
        // Calculates opacity of CFCs
    {
        return (1.1 * PCFC) / (0.015 + PCFC);
    }
    
    double PCO2()
        // Calculates pressure of CO2 after partitioning between cap
        // atmosphere and regolith
    {
        double Pv; // CO2 polar vapour pressure
        double Pa; // Temporary variable for CO2 pressure estimate
        double X,Y; // Working variables
        double top, bottom; // Bisection method variables
        
        Pa = PCO2;
        
        Pv = 1.23E7 * Math.exp(-3168 / Tp);
        
        if (Pv > Pa && pole > 0 && Pv < Pa + pole)
            {
                pole = pole - (Pv - Pa);
                Pa = Pv;
            }
        
        if (Pv > Pa + pole && pole > 0)
            {
                Pa = Pa + pole;
                pole = 0;
            }
        
        if (Pv < Pa)
            {
                pole = pole - (Pv - Pa);
                Pa = Pv;
            }
  
        X = Pa + Pr;
            if (X > totCO2)
                X = totCO2;
        Y = C * Math.exp(-Tp / Td);
        top = totCO2;
        bottom = 0;
        Pa = 0.5 * regolith;
        
        // Calculation of Pr by bisection method
        for (int loop = 1; loop <= 50; loop++)
            {
                if (Y * Math.pow(Pa, 0.275) + Pa < X)
                    bottom = Pa;
                else
                    top = Pa;
                Pa = bottom + (top - bottom) / 2;
            }
        
        Pr = Y * Math.pow(Pa, 0.275);
            if (Pr > regolith)
                {
                    Pa = Pa + Pr - regolith;
                    Pr = regolith;
                }
            
        return Pa;
    }
    
    void biosphere()
        // Calculates habitable characteristics of Mars---more to come
        // habRatio is the fraction of the planetary area above freezing
        // iceLat is the latitude of the freezing isotherm
    {
        if (Tt > 273 && Tp < 273)
        {
            habRatio = Math.pow(((Tt - 273) / (Tt - Tp)), 0.666667);
            iceLat = Math.asin(habRatio);
        }
        
        if (Tt < 273)
        {
            habRatio = 0;
            iceLat = 0;
        }
        
        if (Tp > 273)
        {
            habRatio = 1;
            iceLat = Math.asin(1);
        }
    }
    
    void checkinput() throws OutOfRangeException
        // Checks for unrealistic input
    {
        if (pole < 0 || pole > 100)
            throw new OutOfRangeException();
        if (regolith < 6 || regolith > 1000)
            throw new OutOfRangeException();
        if (Td < 20 || Td > 60)
            throw new OutOfRangeException();
        if (a < 0 || a > 1)
            throw new OutOfRangeException();
        if (S < 0.7 || S > 3)
            throw new OutOfRangeException();
        if (PCO2 < 0 || PCO2 > 3000)
            throw new OutOfRangeException();
        if (PN2 < 0 || PN2 > 3000)
            throw new OutOfRangeException();
        if (PCH4 < 0 || PCH4 > 50000)
            throw new OutOfRangeException();
        if (PNH3 < 0 || PNH3 > 100)
            throw new OutOfRangeException();
        if (PCFC < 0 || PCFC > 100)
            throw new OutOfRangeException();
    }
    
}